use strict;
$|=1;

my $pval_threshold = 0.05;

open IN, "PolII.txt";
open OUT, ">PolII.final.txt";

my %results = ();

my $count = 0;
while (my $line = <IN>) {
    chomp $line;
    my ($chr, $start, $stop, $sample_tags, $control_tags, $enrich, $excess, $pval) = split /\t/, $line;

    $results{$line} = $pval;
    $count++;
}

my @sorted_results_keys = sort{$results{$a} <=> $results{$b}} keys %results;

my $i = 0;
foreach my $line (@sorted_results_keys) {
    $i++;
    my ($chr, $start, $stop, $sample_tags, $control_tags, $enrich, $excess, $pval) = split /\t/, $line;
    
    my $pval_adjusted = $pval * $count / $i; # BH correction for mutiple hypothesis testing

    print OUT "$chr\t$start\t$stop\t$sample_tags\t$control_tags\t$enrich\t$excess\t$pval_adjusted\n" if($pval_adjusted <= $pval_threshold);
}

close IN;
close OUT;
